<!DOCTYPE html>
<html>
  <head>
    <title>FarmBuddy Sensor Data</title>
    <script src="https://canvasjs.com/assets/script/canvasjs.min.js"></script>
  </head>
  <body>
    <div id="chartContainer" style="height: 370px; width: 100%;"></div>

    <script>
      function getData() {
        fetch('/data')
          .then(res => res.json())
          .then(data => {
            const labels = data.map(obj => obj.msg.device_id);
            const tempData = data.map(obj => ({ x: new Date(obj.timestamp), y: obj.msg.temp }));
            const humidData = data.map(obj => ({ x: new Date(obj.timestamp), y: obj.msg.humid }));
            const heatIndexData = data.map(obj => ({ x: new Date(obj.timestamp), y: obj.msg.heatIndex }));

            const chart = new CanvasJS.Chart('chartContainer', {
              title: { text: 'FarmBuddy Sensor Data' },
              axisX: { title: 'Time', valueFormatString: 'MMM DD, HH:mm' },
              axisY: { title: 'Value', suffix: '°C/%', minimum: 0 },
              data: [
                {
                  type: 'line',
                  name: 'Temperature (C)',
                  showInLegend: true,
                  dataPoints: tempData
                },
                {
                  type: 'line',
                  name: 'Humidity (%)',
                  showInLegend: true,
                  dataPoints: humidData
                },
                {
                  type: 'line',
                  name: 'Heat Index (C)',
                  showInLegend: true,
                  dataPoints: heatIndexData
                }
              ]
            });

            chart.render();
          });
      }

      getData(); // initial call to get data and draw chart

      // update chart every 5 seconds
      setInterval(() => {
        getData();
      }, 5000);

    </script>
  </body>
</html>
